# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
from .address import Address
from .age import Age
from .annotation import Annotation
from .attachment import Attachment
from .codeable_concept import CodeableConcept
from .coding import Coding
from .contact_detail import ContactDetail
from .contact_point import ContactPoint
from .contributor import Contributor
from .count import Count
from .data_requirement import DataRequirement
from .data_requirement_code_filter import DataRequirementCodeFilter
from .data_requirement_date_filter import DataRequirementDateFilter
from .data_requirement_sort import DataRequirementSort
from .distance import Distance
from .dosage import Dosage
from .dosage_dose_and_rate import DosageDoseAndRate
from .duration import Duration
from .expression import Expression
from .extension import Extension
from .human_name import HumanName
from .identifier import Identifier
from .meta import Meta
from .money import Money
from .parameter_definition import ParameterDefinition
from .period import Period
from .quantity import Quantity
from .range import Range
from .ratio import Ratio
from .reference import Reference
from .related_artifact import RelatedArtifact
from .sampled_data import SampledData
from .signature import Signature
from .timing import Timing
from .timing_repeat import TimingRepeat
from .trigger_definition import TriggerDefinition
from .usage_context import UsageContext
import typing_extensions
import typing
from ...core.serialization import FieldMetadata
from .id import Id
import pydantic
from .uri import Uri
from .code import Code
from .bulk_data_export_status import BulkDataExportStatus
from .instant import Instant
from .bulk_data_export_output import BulkDataExportOutput
from .bulk_data_export_deleted import BulkDataExportDeleted
from .bulk_data_export_error import BulkDataExportError
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class BulkDataExport(UniversalBaseModel):
    """
    User specific configuration for the Medplum application.
    """

    resource_type: typing_extensions.Annotated[
        typing.Literal["BulkDataExport"], FieldMetadata(alias="resourceType")
    ] = "BulkDataExport"
    id: typing.Optional[Id] = pydantic.Field(default=None)
    """
    The logical id of the resource, as used in the URL for the resource. Once assigned, this value never changes.
    """

    meta: typing.Optional[Meta] = pydantic.Field(default=None)
    """
    The metadata about the resource. This is content that is maintained by the infrastructure. Changes to the content might not always be associated with version changes to the resource.
    """

    implicit_rules: typing_extensions.Annotated[
        typing.Optional[Uri], FieldMetadata(alias="implicitRules")
    ] = pydantic.Field(default=None)
    """
    A reference to a set of rules that were followed when the resource was constructed, and which must be understood when processing the content. Often, this is a reference to an implementation guide that defines the special rules along with other profiles etc.
    """

    language: typing.Optional[Code] = pydantic.Field(default=None)
    """
    The base language in which the resource is written.
    """

    status: BulkDataExportStatus = pydantic.Field()
    """
    The status of the request.
    """

    request_time: typing_extensions.Annotated[
        Instant, FieldMetadata(alias="requestTime")
    ] = pydantic.Field()
    """
    Indicates the server's time when the query is requested.
    """

    transaction_time: typing_extensions.Annotated[
        typing.Optional[Instant], FieldMetadata(alias="transactionTime")
    ] = pydantic.Field(default=None)
    """
    Indicates the server's time when the query is run. The response SHOULD NOT include any resources modified after this instant, and SHALL include any matching resources modified up to and including this instant.
    """

    request: Uri = pydantic.Field()
    """
    The full URL of the original Bulk Data kick-off request. In the case of a POST request, this URL will not include the request parameters.
    """

    requires_access_token: typing_extensions.Annotated[
        typing.Optional[bool], FieldMetadata(alias="requiresAccessToken")
    ] = pydantic.Field(default=None)
    """
    Indicates whether downloading the generated files requires the same authorization mechanism as the $export operation itself.
    """

    output: typing.Optional[typing.List[BulkDataExportOutput]] = pydantic.Field(
        default=None
    )
    """
    An array of file items with one entry for each generated file. If no resources are returned from the kick-off request, the server SHOULD return an empty array.
    """

    deleted: typing.Optional[typing.List[BulkDataExportDeleted]] = pydantic.Field(
        default=None
    )
    """
    An array of deleted file items following the same structure as the output array.
    """

    error: typing.Optional[typing.List[BulkDataExportError]] = pydantic.Field(
        default=None
    )
    """
    Array of message file items following the same structure as the output array.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
