# This file was auto-generated by Fern from our API Definition.

from .base_resource import BaseResource
from .address import Address
from .age import Age
from .annotation import Annotation
from .attachment import Attachment
from .codeable_concept import CodeableConcept
from .coding import Coding
from .contact_detail import ContactDetail
from .contact_point import ContactPoint
from .contributor import Contributor
from .count import Count
from .data_requirement import DataRequirement
from .data_requirement_code_filter import DataRequirementCodeFilter
from .data_requirement_date_filter import DataRequirementDateFilter
from .data_requirement_sort import DataRequirementSort
from .distance import Distance
from .dosage import Dosage
from .dosage_dose_and_rate import DosageDoseAndRate
from .duration import Duration
from .expression import Expression
from .extension import Extension
from .human_name import HumanName
from .identifier import Identifier
from .meta import Meta
from .money import Money
from .parameter_definition import ParameterDefinition
from .period import Period
from .quantity import Quantity
from .range import Range
from .ratio import Ratio
from .reference import Reference
from .related_artifact import RelatedArtifact
from .sampled_data import SampledData
from .signature import Signature
from .timing import Timing
from .timing_repeat import TimingRepeat
from .trigger_definition import TriggerDefinition
from .usage_context import UsageContext
import typing_extensions
import typing
from ...core.serialization import FieldMetadata
from .operation_outcome_issue import OperationOutcomeIssue
import pydantic
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class OperationOutcome(BaseResource):
    """
    A collection of error, warning, or information messages that result from a system action.
    """

    resource_type: typing_extensions.Annotated[
        typing.Literal["OperationOutcome"], FieldMetadata(alias="resourceType")
    ] = "OperationOutcome"
    issue: typing.List[OperationOutcomeIssue] = pydantic.Field()
    """
    An error, warning, or information message that results from a system action.
    """

    status: typing.Optional[int] = pydantic.Field(default=None)
    """
    Optional HTTP status code returned by the operation.
    """

    resource: typing.Optional[typing.Any] = pydantic.Field(default=None)
    """
    Optional Resource created or modified by this operation.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
