# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
from .address import Address
from .age import Age
from .annotation import Annotation
from .attachment import Attachment
from .codeable_concept import CodeableConcept
from .coding import Coding
from .contact_detail import ContactDetail
from .contact_point import ContactPoint
from .contributor import Contributor
from .count import Count
from .data_requirement import DataRequirement
from .data_requirement_code_filter import DataRequirementCodeFilter
from .data_requirement_date_filter import DataRequirementDateFilter
from .data_requirement_sort import DataRequirementSort
from .distance import Distance
from .dosage import Dosage
from .dosage_dose_and_rate import DosageDoseAndRate
from .duration import Duration
from .expression import Expression
from .extension import Extension
from .human_name import HumanName
from .identifier import Identifier
from .meta import Meta
from .money import Money
from .parameter_definition import ParameterDefinition
from .period import Period
from .quantity import Quantity
from .range import Range
from .ratio import Ratio
from .reference import Reference
from .related_artifact import RelatedArtifact
from .sampled_data import SampledData
from .signature import Signature
from .timing import Timing
from .timing_repeat import TimingRepeat
from .trigger_definition import TriggerDefinition
from .usage_context import UsageContext
import typing_extensions
import typing
from ...core.serialization import FieldMetadata
from .id import Id
import pydantic
from .uri import Uri
from .code import Code
from .project_features_item import ProjectFeaturesItem
from .project_secret import ProjectSecret
from .project_site import ProjectSite
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class Project(UniversalBaseModel):
    """
    Encapsulation of resources for a specific project or organization.
    """

    resource_type: typing_extensions.Annotated[
        typing.Literal["Project"], FieldMetadata(alias="resourceType")
    ] = "Project"
    id: typing.Optional[Id] = pydantic.Field(default=None)
    """
    The logical id of the resource, as used in the URL for the resource. Once assigned, this value never changes.
    """

    meta: typing.Optional[Meta] = pydantic.Field(default=None)
    """
    The metadata about the resource. This is content that is maintained by the infrastructure. Changes to the content might not always be associated with version changes to the resource.
    """

    implicit_rules: typing_extensions.Annotated[
        typing.Optional[Uri], FieldMetadata(alias="implicitRules")
    ] = pydantic.Field(default=None)
    """
    A reference to a set of rules that were followed when the resource was constructed, and which must be understood when processing the content. Often, this is a reference to an implementation guide that defines the special rules along with other profiles etc.
    """

    language: typing.Optional[Code] = pydantic.Field(default=None)
    """
    The base language in which the resource is written.
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    A name associated with the Project.
    """

    description: typing.Optional[str] = pydantic.Field(default=None)
    """
    A summary, characterization or explanation of the Project.
    """

    super_admin: typing_extensions.Annotated[
        typing.Optional[bool], FieldMetadata(alias="superAdmin")
    ] = pydantic.Field(default=None)
    """
    Whether this project is the super administrator project. A super administrator is a user who has complete access to all resources in all projects.
    """

    strict_mode: typing_extensions.Annotated[
        typing.Optional[bool], FieldMetadata(alias="strictMode")
    ] = pydantic.Field(default=None)
    """
    Whether this project uses strict FHIR validation.
    """

    check_references_on_write: typing_extensions.Annotated[
        typing.Optional[bool], FieldMetadata(alias="checkReferencesOnWrite")
    ] = pydantic.Field(default=None)
    """
    Whether this project uses referential integrity on write operations such as 'create' and 'update'.
    """

    owner: typing.Optional[Reference] = pydantic.Field(default=None)
    """
    The user who owns the project.
    """

    features: typing.Optional[typing.List[ProjectFeaturesItem]] = pydantic.Field(
        default=None
    )
    """
    A list of optional features that are enabled for the project.
    """

    default_patient_access_policy: typing_extensions.Annotated[
        typing.Optional[Reference], FieldMetadata(alias="defaultPatientAccessPolicy")
    ] = pydantic.Field(default=None)
    """
    The default access policy for patients using open registration.
    """

    secret: typing.Optional[typing.List[ProjectSecret]] = pydantic.Field(default=None)
    """
    Secure environment variable that can be used to store secrets for bots.
    """

    site: typing.Optional[typing.List[ProjectSite]] = pydantic.Field(default=None)
    """
    Web application or web site that is associated with the project.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
