# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
from .address import Address
from .age import Age
from .annotation import Annotation
from .attachment import Attachment
from .codeable_concept import CodeableConcept
from .coding import Coding
from .contact_detail import ContactDetail
from .contact_point import ContactPoint
from .contributor import Contributor
from .count import Count
from .data_requirement import DataRequirement
from .data_requirement_code_filter import DataRequirementCodeFilter
from .data_requirement_date_filter import DataRequirementDateFilter
from .data_requirement_sort import DataRequirementSort
from .distance import Distance
from .dosage import Dosage
from .dosage_dose_and_rate import DosageDoseAndRate
from .duration import Duration
from .expression import Expression
from .extension import Extension
from .human_name import HumanName
from .identifier import Identifier
from .meta import Meta
from .money import Money
from .parameter_definition import ParameterDefinition
from .period import Period
from .quantity import Quantity
from .range import Range
from .ratio import Ratio
from .reference import Reference
from .related_artifact import RelatedArtifact
from .sampled_data import SampledData
from .signature import Signature
from .timing import Timing
from .timing_repeat import TimingRepeat
from .trigger_definition import TriggerDefinition
from .usage_context import UsageContext
import typing
import pydantic
import typing_extensions
from ...core.serialization import FieldMetadata
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class SpecimenCollection(UniversalBaseModel):
    """
    A sample to be used for analysis.
    """

    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    Unique id for the element within a resource (for internal references). This may be any string value that does not contain spaces.
    """

    extension: typing.Optional[typing.List[Extension]] = pydantic.Field(default=None)
    """
    May be used to represent additional information that is not part of the basic definition of the element. To make the use of extensions safe and manageable, there is a strict set of governance applied to the definition and use of extensions. Though any implementer can define an extension, there is a set of requirements that SHALL be met as part of the definition of the extension.
    """

    modifier_extension: typing_extensions.Annotated[
        typing.Optional[typing.List[Extension]],
        FieldMetadata(alias="modifierExtension"),
    ] = pydantic.Field(default=None)
    """
    May be used to represent additional information that is not part of the basic definition of the element and that modifies the understanding of the element in which it is contained and/or the understanding of the containing element's descendants. Usually modifier elements provide negation or qualification. To make the use of extensions safe and manageable, there is a strict set of governance applied to the definition and use of extensions. Though any implementer can define an extension, there is a set of requirements that SHALL be met as part of the definition of the extension. Applications processing a resource are required to check for modifier extensions. Modifier extensions SHALL NOT change the meaning of any elements on Resource or DomainResource (including cannot change the meaning of modifierExtension itself).
    """

    collector: typing.Optional[Reference] = pydantic.Field(default=None)
    """
    Person who collected the specimen.
    """

    collected_date_time: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="collectedDateTime")
    ] = pydantic.Field(default=None)
    """
    Time when specimen was collected from subject - the physiologically relevant time.
    """

    collected_period: typing_extensions.Annotated[
        typing.Optional[Period], FieldMetadata(alias="collectedPeriod")
    ] = pydantic.Field(default=None)
    """
    Time when specimen was collected from subject - the physiologically relevant time.
    """

    duration: typing.Optional[Duration] = pydantic.Field(default=None)
    """
    The span of time over which the collection of a specimen occurred.
    """

    quantity: typing.Optional[Quantity] = pydantic.Field(default=None)
    """
    The quantity of specimen collected; for instance the volume of a blood sample, or the physical measurement of an anatomic pathology sample.
    """

    method: typing.Optional[CodeableConcept] = pydantic.Field(default=None)
    """
    A coded value specifying the technique that is used to perform the procedure.
    """

    body_site: typing_extensions.Annotated[
        typing.Optional[CodeableConcept], FieldMetadata(alias="bodySite")
    ] = pydantic.Field(default=None)
    """
    Anatomical location from which the specimen was collected (if subject is a patient). This is the target site. This element is not used for environmental specimens.
    """

    fasting_status_codeable_concept: typing_extensions.Annotated[
        typing.Optional[CodeableConcept],
        FieldMetadata(alias="fastingStatusCodeableConcept"),
    ] = pydantic.Field(default=None)
    """
    Abstinence or reduction from some or all food, drink, or both, for a period of time prior to sample collection.
    """

    fasting_status_duration: typing_extensions.Annotated[
        typing.Optional[Duration], FieldMetadata(alias="fastingStatusDuration")
    ] = pydantic.Field(default=None)
    """
    Abstinence or reduction from some or all food, drink, or both, for a period of time prior to sample collection.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
