# This file was auto-generated by Fern from our API Definition.

from .base_resource import BaseResource
from .address import Address
from .age import Age
from .annotation import Annotation
from .attachment import Attachment
from .codeable_concept import CodeableConcept
from .coding import Coding
from .contact_detail import ContactDetail
from .contact_point import ContactPoint
from .contributor import Contributor
from .count import Count
from .data_requirement import DataRequirement
from .data_requirement_code_filter import DataRequirementCodeFilter
from .data_requirement_date_filter import DataRequirementDateFilter
from .data_requirement_sort import DataRequirementSort
from .distance import Distance
from .dosage import Dosage
from .dosage_dose_and_rate import DosageDoseAndRate
from .duration import Duration
from .expression import Expression
from .extension import Extension
from .human_name import HumanName
from .identifier import Identifier
from .meta import Meta
from .money import Money
from .parameter_definition import ParameterDefinition
from .period import Period
from .quantity import Quantity
from .range import Range
from .ratio import Ratio
from .reference import Reference
from .related_artifact import RelatedArtifact
from .sampled_data import SampledData
from .signature import Signature
from .timing import Timing
from .timing_repeat import TimingRepeat
from .trigger_definition import TriggerDefinition
from .usage_context import UsageContext
import typing_extensions
import typing
from ...core.serialization import FieldMetadata
import pydantic
from .specimen_definition_type_tested import SpecimenDefinitionTypeTested
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class SpecimenDefinition(BaseResource):
    """
    A kind of specimen with associated set of requirements.
    """

    resource_type: typing_extensions.Annotated[
        typing.Literal["SpecimenDefinition"], FieldMetadata(alias="resourceType")
    ] = "SpecimenDefinition"
    identifier: typing.Optional[Identifier] = pydantic.Field(default=None)
    """
    A business identifier associated with the kind of specimen.
    """

    type_collected: typing_extensions.Annotated[
        typing.Optional[CodeableConcept], FieldMetadata(alias="typeCollected")
    ] = pydantic.Field(default=None)
    """
    The kind of material to be collected.
    """

    patient_preparation: typing_extensions.Annotated[
        typing.Optional[typing.List[CodeableConcept]],
        FieldMetadata(alias="patientPreparation"),
    ] = pydantic.Field(default=None)
    """
    Preparation of the patient for specimen collection.
    """

    time_aspect: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="timeAspect")
    ] = pydantic.Field(default=None)
    """
    Time aspect of specimen collection (duration or offset).
    """

    collection: typing.Optional[typing.List[CodeableConcept]] = pydantic.Field(
        default=None
    )
    """
    The action to be performed for collecting the specimen.
    """

    type_tested: typing_extensions.Annotated[
        typing.Optional[typing.List[SpecimenDefinitionTypeTested]],
        FieldMetadata(alias="typeTested"),
    ] = pydantic.Field(default=None)
    """
    Specimen conditioned in a container as expected by the testing laboratory.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
