# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
from .address import Address
from .age import Age
from .annotation import Annotation
from .attachment import Attachment
from .codeable_concept import CodeableConcept
from .coding import Coding
from .contact_detail import ContactDetail
from .contact_point import ContactPoint
from .contributor import Contributor
from .count import Count
from .data_requirement import DataRequirement
from .data_requirement_code_filter import DataRequirementCodeFilter
from .data_requirement_date_filter import DataRequirementDateFilter
from .data_requirement_sort import DataRequirementSort
from .distance import Distance
from .dosage import Dosage
from .dosage_dose_and_rate import DosageDoseAndRate
from .duration import Duration
from .expression import Expression
from .extension import Extension
from .human_name import HumanName
from .identifier import Identifier
from .meta import Meta
from .money import Money
from .parameter_definition import ParameterDefinition
from .period import Period
from .quantity import Quantity
from .range import Range
from .ratio import Ratio
from .reference import Reference
from .related_artifact import RelatedArtifact
from .sampled_data import SampledData
from .signature import Signature
from .timing import Timing
from .timing_repeat import TimingRepeat
from .trigger_definition import TriggerDefinition
from .usage_context import UsageContext
import typing
import pydantic
import typing_extensions
from ...core.serialization import FieldMetadata
from .id import Id
from .structure_map_source_list_mode import StructureMapSourceListMode
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class StructureMapSource(UniversalBaseModel):
    """
    A Map of relationships between 2 structures that can be used to transform data.
    """

    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    Unique id for the element within a resource (for internal references). This may be any string value that does not contain spaces.
    """

    extension: typing.Optional[typing.List[Extension]] = pydantic.Field(default=None)
    """
    May be used to represent additional information that is not part of the basic definition of the element. To make the use of extensions safe and manageable, there is a strict set of governance applied to the definition and use of extensions. Though any implementer can define an extension, there is a set of requirements that SHALL be met as part of the definition of the extension.
    """

    modifier_extension: typing_extensions.Annotated[
        typing.Optional[typing.List[Extension]],
        FieldMetadata(alias="modifierExtension"),
    ] = pydantic.Field(default=None)
    """
    May be used to represent additional information that is not part of the basic definition of the element and that modifies the understanding of the element in which it is contained and/or the understanding of the containing element's descendants. Usually modifier elements provide negation or qualification. To make the use of extensions safe and manageable, there is a strict set of governance applied to the definition and use of extensions. Though any implementer can define an extension, there is a set of requirements that SHALL be met as part of the definition of the extension. Applications processing a resource are required to check for modifier extensions. Modifier extensions SHALL NOT change the meaning of any elements on Resource or DomainResource (including cannot change the meaning of modifierExtension itself).
    """

    context: typing.Optional[Id] = pydantic.Field(default=None)
    """
    Type or variable this rule applies to.
    """

    min: typing.Optional[int] = pydantic.Field(default=None)
    """
    Specified minimum cardinality for the element. This is optional; if present, it acts an implicit check on the input content.
    """

    max: typing.Optional[str] = pydantic.Field(default=None)
    """
    Specified maximum cardinality for the element - a number or a "_". This is optional; if present, it acts an implicit check on the input content (_ just serves as documentation; it's the default value).
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    Specified type for the element. This works as a condition on the mapping - use for polymorphic elements.
    """

    default_value_base_64_binary: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueBase64Binary")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_boolean: typing_extensions.Annotated[
        typing.Optional[bool], FieldMetadata(alias="defaultValueBoolean")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_canonical: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueCanonical")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_code: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueCode")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_date: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueDate")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_date_time: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueDateTime")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_decimal: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="defaultValueDecimal")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_id: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueId")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_instant: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueInstant")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_integer: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="defaultValueInteger")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_markdown: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueMarkdown")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_oid: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueOid")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_positive_int: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="defaultValuePositiveInt")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_string: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueString")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_time: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueTime")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_unsigned_int: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="defaultValueUnsignedInt")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_uri: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueUri")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_url: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueUrl")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_uuid: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="defaultValueUuid")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_address: typing_extensions.Annotated[
        typing.Optional[Address], FieldMetadata(alias="defaultValueAddress")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_age: typing_extensions.Annotated[
        typing.Optional[Age], FieldMetadata(alias="defaultValueAge")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_annotation: typing_extensions.Annotated[
        typing.Optional[Annotation], FieldMetadata(alias="defaultValueAnnotation")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_attachment: typing_extensions.Annotated[
        typing.Optional[Attachment], FieldMetadata(alias="defaultValueAttachment")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_codeable_concept: typing_extensions.Annotated[
        typing.Optional[CodeableConcept],
        FieldMetadata(alias="defaultValueCodeableConcept"),
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_coding: typing_extensions.Annotated[
        typing.Optional[Coding], FieldMetadata(alias="defaultValueCoding")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_contact_point: typing_extensions.Annotated[
        typing.Optional[ContactPoint], FieldMetadata(alias="defaultValueContactPoint")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_count: typing_extensions.Annotated[
        typing.Optional[Count], FieldMetadata(alias="defaultValueCount")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_distance: typing_extensions.Annotated[
        typing.Optional[Distance], FieldMetadata(alias="defaultValueDistance")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_duration: typing_extensions.Annotated[
        typing.Optional[Duration], FieldMetadata(alias="defaultValueDuration")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_human_name: typing_extensions.Annotated[
        typing.Optional[HumanName], FieldMetadata(alias="defaultValueHumanName")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_identifier: typing_extensions.Annotated[
        typing.Optional[Identifier], FieldMetadata(alias="defaultValueIdentifier")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_money: typing_extensions.Annotated[
        typing.Optional[Money], FieldMetadata(alias="defaultValueMoney")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_period: typing_extensions.Annotated[
        typing.Optional[Period], FieldMetadata(alias="defaultValuePeriod")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_quantity: typing_extensions.Annotated[
        typing.Optional[Quantity], FieldMetadata(alias="defaultValueQuantity")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_range: typing_extensions.Annotated[
        typing.Optional[Range], FieldMetadata(alias="defaultValueRange")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_ratio: typing_extensions.Annotated[
        typing.Optional[Ratio], FieldMetadata(alias="defaultValueRatio")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_reference: typing_extensions.Annotated[
        typing.Optional[Reference], FieldMetadata(alias="defaultValueReference")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_sampled_data: typing_extensions.Annotated[
        typing.Optional[SampledData], FieldMetadata(alias="defaultValueSampledData")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_signature: typing_extensions.Annotated[
        typing.Optional[Signature], FieldMetadata(alias="defaultValueSignature")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_timing: typing_extensions.Annotated[
        typing.Optional[Timing], FieldMetadata(alias="defaultValueTiming")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_contact_detail: typing_extensions.Annotated[
        typing.Optional[ContactDetail], FieldMetadata(alias="defaultValueContactDetail")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_contributor: typing_extensions.Annotated[
        typing.Optional[Contributor], FieldMetadata(alias="defaultValueContributor")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_data_requirement: typing_extensions.Annotated[
        typing.Optional[DataRequirement],
        FieldMetadata(alias="defaultValueDataRequirement"),
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_expression: typing_extensions.Annotated[
        typing.Optional[Expression], FieldMetadata(alias="defaultValueExpression")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_parameter_definition: typing_extensions.Annotated[
        typing.Optional[ParameterDefinition],
        FieldMetadata(alias="defaultValueParameterDefinition"),
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_related_artifact: typing_extensions.Annotated[
        typing.Optional[RelatedArtifact],
        FieldMetadata(alias="defaultValueRelatedArtifact"),
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_trigger_definition: typing_extensions.Annotated[
        typing.Optional[TriggerDefinition],
        FieldMetadata(alias="defaultValueTriggerDefinition"),
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_usage_context: typing_extensions.Annotated[
        typing.Optional[UsageContext], FieldMetadata(alias="defaultValueUsageContext")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_dosage: typing_extensions.Annotated[
        typing.Optional[Dosage], FieldMetadata(alias="defaultValueDosage")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    default_value_meta: typing_extensions.Annotated[
        typing.Optional[Meta], FieldMetadata(alias="defaultValueMeta")
    ] = pydantic.Field(default=None)
    """
    A value to use if there is no existing value in the source object.
    """

    element: typing.Optional[str] = pydantic.Field(default=None)
    """
    Optional field for this source.
    """

    list_mode: typing_extensions.Annotated[
        typing.Optional[StructureMapSourceListMode], FieldMetadata(alias="listMode")
    ] = pydantic.Field(default=None)
    """
    How to handle the list mode for this element.
    """

    variable: typing.Optional[Id] = pydantic.Field(default=None)
    """
    Named context for field, if a field is specified.
    """

    condition: typing.Optional[str] = pydantic.Field(default=None)
    """
    FHIRPath expression - must be true or the rule does not apply.
    """

    check: typing.Optional[str] = pydantic.Field(default=None)
    """
    FHIRPath expression - must be true or the mapping engine throws an error instead of completing.
    """

    log_message: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="logMessage")
    ] = pydantic.Field(default=None)
    """
    A FHIRPath expression which specifies a message to put in the transform log when content matching the source rule is found.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
