# This file was auto-generated by Fern from our API Definition.

from ....core.pydantic_utilities import UniversalBaseModel
import typing
from .patient_consolidated_data_status import PatientConsolidatedDataStatus
from ....core.pydantic_utilities import IS_PYDANTIC_V2
import pydantic


class GetConsolidatedQueryStatusResponse(UniversalBaseModel):
    """
    Examples
    --------
    from metriport.medical.fhir import (
        GetConsolidatedQueryStatusResponse,
        PatientConsolidatedDataStatus,
    )

    GetConsolidatedQueryStatusResponse(
        queries=[
            PatientConsolidatedDataStatus(
                request_id="00000000-0000-0000-0000-000000000000",
                started_at="2023-07-27T21:29:31.491+00:00",
                date_from="2023-07-27",
                date_to="2024-07-27",
                conversion_type="html",
                status="processing",
            ),
            PatientConsolidatedDataStatus(
                request_id="00000000-0000-0000-0000-000000000000",
                started_at="2023-07-27T21:29:31.491+00:00",
                date_from="2023-07-27",
                date_to="2024-07-27",
                conversion_type="html",
                status="processing",
            ),
        ],
        message="Trigger a new query by POST /patient/:id/consolidated/query; data will be sent through Webhook",
    )
    """

    queries: typing.List[PatientConsolidatedDataStatus]
    message: typing.Optional[str] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
