# This file was auto-generated by Fern from our API Definition.

from ....core.pydantic_utilities import UniversalBaseModel
from ....fhir.types.address import Address
from ....fhir.types.age import Age
from ....fhir.types.annotation import Annotation
from ....fhir.types.attachment import Attachment
from ....fhir.types.codeable_concept import CodeableConcept
from ....fhir.types.coding import Coding
from ....fhir.types.contact_detail import ContactDetail
from ....fhir.types.contact_point import ContactPoint
from ....fhir.types.contributor import Contributor
from ....fhir.types.count import Count
from ....fhir.types.data_requirement import DataRequirement
from ....fhir.types.data_requirement_code_filter import DataRequirementCodeFilter
from ....fhir.types.data_requirement_date_filter import DataRequirementDateFilter
from ....fhir.types.data_requirement_sort import DataRequirementSort
from ....fhir.types.distance import Distance
from ....fhir.types.dosage import Dosage
from ....fhir.types.dosage_dose_and_rate import DosageDoseAndRate
from ....fhir.types.duration import Duration
from ....fhir.types.expression import Expression
from ....fhir.types.extension import Extension
from ....fhir.types.human_name import HumanName
from ....fhir.types.identifier import Identifier
from ....fhir.types.meta import Meta
from ....fhir.types.money import Money
from ....fhir.types.parameter_definition import ParameterDefinition
from ....fhir.types.period import Period
from ....fhir.types.quantity import Quantity
from ....fhir.types.range import Range
from ....fhir.types.ratio import Ratio
from ....fhir.types.reference import Reference
from ....fhir.types.related_artifact import RelatedArtifact
from ....fhir.types.sampled_data import SampledData
from ....fhir.types.signature import Signature
from ....fhir.types.timing import Timing
from ....fhir.types.timing_repeat import TimingRepeat
from ....fhir.types.trigger_definition import TriggerDefinition
from ....fhir.types.usage_context import UsageContext
import typing_extensions
from ....core.serialization import FieldMetadata
import pydantic
import typing
from .consolidated_webhook_status import ConsolidatedWebhookStatus
from ....fhir.types.bundle import Bundle
from .filters import Filters
from ....core.pydantic_utilities import IS_PYDANTIC_V2


class PayloadPatient(UniversalBaseModel):
    patient_id: typing_extensions.Annotated[str, FieldMetadata(alias="patientId")] = (
        pydantic.Field()
    )
    """
    The ID of the patient.
    """

    external_id: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="externalId")
    ] = pydantic.Field(default=None)
    """
    The external ID of the patient.
    """

    status: ConsolidatedWebhookStatus = pydantic.Field()
    """
    The status of the webhook.
    """

    bundle: typing.Optional[Bundle] = pydantic.Field(default=None)
    """
    The FHIR bundle with the patient's consolidated data.
    """

    filters: typing.Optional[Filters] = pydantic.Field(default=None)
    """
    The filters used to obtain the bundle.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
